const windowsLogger = require('./windows')
const syslogLogger = require('./syslog')

const isWindows = process.platform === 'win32'

let logger
if (isWindows) {
  windowsLogger.debug('Using windows logger')
  logger = windowsLogger
} else {
  syslogLogger.debug('Using syslog logger')
  logger = syslogLogger
}

module.exports = logger
